package com.jojubanking.boot.module.system.service.ksinfo;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.ksinfo.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.ksinfo.KsInfoDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

/**
 * 科室信息 Service 接口
 *
 * @author admin
 */
public interface KsInfoService {

    /**
     * 创建科室信息
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createKsInfo(@Valid KsInfoCreateReqVO createReqVO);

    /**
     * 更新科室信息
     *
     * @param updateReqVO 更新信息
     */
    void updateKsInfo(@Valid KsInfoUpdateReqVO updateReqVO);

    /**
     * 删除科室信息
     *
     * @param id 编号
     */
    void deleteKsInfo(Integer id);

    /**
     * 获得科室信息
     *
     * @param id 编号
     * @return 科室信息
     */
    KsInfoDO getKsInfo(Integer id);

    /**
     * 获得科室信息列表
     *
     * @param ids 编号
     * @return 科室信息列表
     */
    List<KsInfoDO> getKsInfoList(Collection<Integer> ids);

    /**
     * 获得科室信息分页
     *
     * @param pageReqVO 分页查询
     * @return 科室信息分页
     */
    PageResult<KsInfoDO> getKsInfoPage(KsInfoPageReqVO pageReqVO);

    PageResult<KsInfoDO> getDzInfoPage(KsInfoPageReqVO pageReqVO);

    /**
     * 获得科室信息列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 科室信息列表
     */
    List<KsInfoDO> getKsInfoList(KsInfoExportReqVO exportReqVO);

    void updateKsInfoPerDay(String kscode, String name, String departtype);
}
